<?php
/**
 * @copyright (C) 2007 by Slashes & Dots Sdn Bhd - All rights reserved!
 * @license http://www.azrul.com Copyrighted Commercial Software
 *
 * Rem:
 * This file is the library for plugins which allows myblog to load plugins / mambots
 * that is installed on a joomla site. 
 **/
(defined('_VALID_MOS') OR defined('_JEXEC')) or die('Direct Access to this location is not allowed.');

// Include our custom cmslib if its not defined
if(!defined('CMSLIB_DEFINED'))
	include_once ((dirname((dirname(dirname(dirname(__FILE__)))))) . '/components/libraries/cmslib/spframework.php');

global $mainframe, $_MY_CONFIG;

if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
	global $_MAMBOTS;
}

class MYPlugins{
	
	/** Private Properties **/
	var $_folder	= '';		// Plugins / Mambots folder
	var $_db		= null;
	var $_cms		= null;

	var $_events	= null;
	
	function MYPlugins(){
		$this->_cms	=& cmsInstance('CMSCore');

		// Include our custom cmslib if its not defined
		if(!defined('MYPluginsDB'))
			include_once (MY_MODEL_PATH . '/plugins.db.php');

		$this->_db	= new MYPluginsDB();

		// Set the plugins / mambots folder for this specific environment.
		$this->_folder	= $this->_cms->get_path('plugins');
	}
	
	/**
	 * Load plugins for specific event.
	 **/	 	
	function load(){
		global $mainframe;
		$plugins	= $this->_db->getPlugins();
		
		if($plugins){
			foreach($plugins as $plugin){
			    // Instead of including the mambots, we allow the mainframe mambot to include for us.
			    // so that other module that has triggers would not come up with an error.
			    $plugin->folder 		= 'content';
			    $plugin->published 	= '1';
			    $plugin->params		= null; // no params
			    
				@$_GET['task']  	= 'view';
				@$_GET['option']    = 'com_content';
	
				if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
					global $_MAMBOTS;
					$_MAMBOTS->loadBot($plugin->folder, $plugin->element, $plugin->published, $plugin->params);

					$mambotsToInit=@$_MAMBOTS->_events['onPrepareContent'];
					if ($mambotsToInit){ 
						foreach ($mambotsToInit as $mambotToInit){
							$funcName=$mambotToInit[0];
							$this->register('onPrepareContent',$funcName,"","1");
						}
					}
					
					$mambotsToInit=@$_MAMBOTS->_events['onBeforeDisplayContent'];
					if($mambotsToInit){ 
						foreach ($mambotsToInit as $mambotToInit){
							$funcName=$mambotToInit[0];
							$this->register('onBeforeDisplayContent',$funcName,"","1");
						}
					}
					
					$mambotsToInit=@$_MAMBOTS->_events['onAfterDisplayContent'];
					if ($mambotsToInit) {
						foreach ($mambotsToInit as $mambotToInit) {
							$funcName=$mambotToInit[0];
							$this->register('onAfterDisplayContent',$funcName,"","1");
						}
					}
				}
				else{
					// Import plugin.
					JPluginHelper::importPlugin('content', $plugin->element);
					$dispatcher	=& JDispatcher::getInstance();
					//$de =& JPluginHelper::getPlugin('content', $plugin->element);

					foreach($dispatcher->_observers as $observer){
						if(is_array($observer)){
							if($observer['event'] == 'onPrepareContent'){
								$this->register('onPrepareContent', $observer['handler'], $plugin->params, $plugin->published);
							}

							if($observer['event'] == 'onBeforeDisplayContent'){
								$this->register('onPrepareContent', $observer['handler'], $plugin->params, $plugin->published);
							}

							if($observer['event'] == 'onAfterDisplayContent'){
								$this->register('onPrepareContent', $observer['handler'], $plugin->params, $plugin->published);
							}
						}
						else if(is_object($observer))
						{
							// Classes type of plugins
						}
					}
				}
			}// End for loop
		}// End if
	}// End function

	/**
	 * Register specific plugin
	 **/	 	
	function register($event, $handler, $params, $published = 1){
		
		if(!isset($this->_events[$event])) 
			$this->_events[$event]	= array();
	
		if(!in_array($handler, $this->_events[$event]))
			$this->_events[$event][] = $handler;
	}
	
	function _callFunction($handler, &$row, &$params, $page)
	{
		if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO)
		{
			return $handler(true, $row, $params, $page);
		}
		else
		{
			// Assuming this is Joomla 1.5
			return $handler($row, $params, $page);
		}
	}
	
	function trigger($event, &$row, &$params, $page = '0'){
		$result	= '';

		if(isset($this->_events[$event])){
			foreach($this->_events[$event] as $handler){
				//echo $handler . '<br />';
				//echo "<!-- params: {$handler} -->";
				//echo "<!-- rowtext: " . htmlspecialchars($row->text) . "-->\n\n";
				
				if($event == 'onBeforeDisplayContent' || $event == 'onAfterDisplayContent'){
					if(function_exists($handler))
					{
						$result	.= $this->_callFunction($handler, $row, $params, $page);
						//	$result	.= $handler($row, $params, $page);
					}
				}
				else
				{
					if(function_exists($handler))
					{
						$result	.= $this->_callFunction($handler, $row, $params, $page);
						//$result	.= $handler( $row, $params, $page);
					}
				}
				//echo "<!-- rowtext after: " . htmlspecialchars($row->text) . "-->\n\n";
			}
		}
 		return $result;
	}
	
	/**
	 * Initialize all mambots / plugins to be stored into #__myblog_mambots	 
	 **/	 	
	function init(){
		$this->_db->initPlugins();
	}
	
	function get($limitstart, $limit){
		return $this->_db->get($limitstart, $limit);
	}
}